'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _base = require('../../base');

var _base2 = _interopRequireDefault(_base);

var _api = require('../../utils/api');

var _api2 = _interopRequireDefault(_api);

var _query = require('../../utils/query');

var _query2 = _interopRequireDefault(_query);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class GetCommand extends _base2.default {
	async run() {
		const { args: { ids } } = this.parse(GetCommand);
		const req = ids.map(id => ({
			query: {
				limit: 1,
				id
			},
			placeholder: {
				id,
				message: 'Transaction not found.'
			}
		}));
		const client = (0, _api2.default)(this.userConfig.api);
		const results = await (0, _query2.default)(client, 'transactions', req);
		this.print(results);
	}
}

exports.default = GetCommand; /*
                               * LiskHQ/lisk-commander
                               * Copyright © 2017–2018 Lisk Foundation
                               *
                               * See the LICENSE file at the top-level directory of this distribution
                               * for licensing information.
                               *
                               * Unless otherwise agreed in a custom licensing agreement with the Lisk Foundation,
                               * no part of this software, including this file, may be copied, modified,
                               * propagated, or distributed except according to the terms contained in the
                               * LICENSE file.
                               *
                               * Removal or modification of this copyright notice is prohibited.
                               *
                               */

GetCommand.args = [{
	name: 'ids',
	required: true,
	description: 'Comma-separated transaction ID(s) to get information about.',
	parse: input => input.split(',').filter(Boolean)
}];

GetCommand.flags = Object.assign({}, _base2.default.flags);

GetCommand.description = `
Gets transaction information from the blockchain.
`;

GetCommand.examples = ['transaction:get 10041151099734832021', 'transaction:get 10041151099734832021,1260076503909567890'];